> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.propexo.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.propexo.com/_mcp/server.

# Get all units

GET https://api.propexo.com/v1/units/

Get all units

Reference: https://docs.propexo.com/api-reference/appfolio/units/get-all-units

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://api.propexo.com` (Production, default)
- `https://api.sandbox.propexo.com` (Sandbox)

## Request

### Query parameters

- `order-by` (string, optional, default: created_at:desc) — Order the results by a field. Optionally include asc or desc preceded by a colon (default is asc). Example: ?order-by=updated_at:desc
- `updated_at_gte` (string, optional, nullable) — Filter to records updated at or after this datetime. Format: ISO 8601 (e.g. 2026-01-01T00:00:00Z)
- `updated_at_lte` (string, optional, nullable) — Filter to records updated at or before this datetime. Format: ISO 8601 (e.g. 2026-12-31T23:59:59Z)
- `last_seen_gte` (string, optional, nullable) — Filter to records whose last_seen date is on or after this datetime. Format: ISO 8601 (e.g. 2026-01-01T00:00:00Z)
- `last_seen_lte` (string, optional, nullable) — Filter to records whose last_seen date is on or before this datetime. Format: ISO 8601 (e.g. 2026-12-31T23:59:59Z)
- `offset` (integer, optional, nullable, default: 0) — Can be used for paginating results
- `limit` (integer, optional, nullable, default: 100) — A number between 1 and 250 to determine the number of results to return in a single query
- `x_id` (string, optional) — The external unit id
- `x_property_id` (string, optional) — Deprecated: Use the Propexo property_id instead
- `location_id` (string, optional) — The Propexo unique identifier for the location associated with the property (exclusive to Rent Manager integrations). This is always null for non-Rent Manager integrations.
- `property_id` (string, optional) — The Propexo property id
- `integration_id` (string, optional) — The Propexo integration id
- `integration_vendor` (enum, optional) — The integration vendor for the unit.
  - Allowed values: `APPFOLIO`, `BUILDIUM`, `ENTRATA`, `MRI`, `PROPERTYWARE`, `PROPERTYWARE_REST`, `REALPAGE`, `REALPAGE_RPX`, `RENTMANAGER`, `RENTVINE`, `RESMAN`, `YARDI`, `YARDI_REST`
- `unit_number` (string, optional) — The number of the unit. When using this, the Propexo `property_id` filter must be added as well.

## Response

### 200

Successful response

- `meta` (ResponseMeta, required)
- `results` (list of V1UnitsGetOutputResultsItems, required)

## Errors

### 400 Bad Request Error

Bad Request

- `error` (ErrorResponseError, required)

## Types

### ResponseMeta

- `orderBy` (list of ResponseMetaOrderByItems, required) — The order of the results
- `offset` (integer, optional) — The offset of the first result
- `limit` (integer, optional) — The number of results to return
- `hasMore` (boolean, optional, nullable) — Whether there are more results
- `total` (integer, optional) — The total number of results

### V1UnitsGetOutputResultsItems

- `id` (string, required) — The Propexo unique identifier for the unit
- `created_at` (string, required) — The date record first entered Propexo
- `updated_at` (string, required) — The date record was last updated in Propexo
- `last_seen` (string, required, nullable) — The date the record was last seen from the PMS
- `x_id` (string, required) — The external ID from the integration vendor | Method | Interface | |---|---| | /v0/units | Units |
- `x_property_id` (string, required) — The external ID of the property from the integration vendor | Method | Interface | |---|---| | /v0/units | Units |
- `x_floor_plan_id` (string, required, nullable) — The external ID of the floor plan from the integration vendor | Method | Interface | |---|---| | /v0/units | Units |
- `x_unit_type_id` (any, required) — The external ID of the unit type from the integration vendorThis field will always be null for APPFOLIO
- `bathrooms` (string, required, nullable) — The number of bathrooms associated with the unit | Method | Interface | |---|---| | /v0/units | Units |
- `bathrooms_full` (double, required, nullable) — The number of full bathrooms associated with the unit | Method | Interface | |---|---| | /v0/units | Units |
- `bathrooms_half` (double, required, nullable) — The number of half bathrooms associated with the unit | Method | Interface | |---|---| | /v0/units | Units |
- `bedrooms` (string, required, nullable) — The number of bedrooms associated with the unit | Method | Interface | |---|---| | /v0/units | Units |
- `building_name` (any, required) — The building name associated with the unitThis field will always be null for APPFOLIO
- `building_number` (any, required) — The building number associated with the unitThis field will always be null for APPFOLIO
- `city` (string, required, nullable) — The city associated with the unit | Method | Interface | |---|---| | /v0/units | Units |
- `country` (any, required) — The country associated with the unitThis field will always be null for APPFOLIO
- `custom_data` (V1UnitsGetOutputResultsItemsCustomData, required, nullable)
- `floor_plan_code` (string, required, nullable) — The external ID of the floor plan associated with the unit | Method | Interface | |---|---| | /v0/units | Units |
- `floor_plan_name` (string, required, nullable) — The floor plan name associated with the unit | Method | Interface | |---|---| | /v0/units | Units |
- `floor` (any, required) — The floor number/name associated with the unitThis field will always be null for APPFOLIO
- `is_available` (boolean, required, nullable) — Whether the unit is available | Method | Interface | |---|---| | /v0/units | Units |
- `is_furnished` (any, required) — Whether the unit is furnishedThis field will always be null for APPFOLIO
- `is_vacant` (boolean, required, nullable) — Whether the unit is vacantThis is derived from the "Status" field being "Vacant". If you'd like the raw value of this field, contact support. | Method | Interface | | --------- | --------- | | /v0/units | Units |
- `number` (string, required, nullable) — The unit number | Method | Interface | |---|---| | /v0/units | Units |
- `rent_amount_market_in_cents` (double, required, nullable) — The market rent amount in cents for the unit | Method | Interface | |---|---| | /v0/units | Units |
- `rent_amount_max_in_cents` (any, required) — The maximum rent amount in centsThis field will always be null for APPFOLIO
- `rent_amount_min_in_cents` (any, required) — The minimum rent amount in centsThis field will always be null for APPFOLIO
- `square_feet` (integer, required, nullable) — The square footage of the unit | Method | Interface | |---|---| | /v0/units | Units |
- `state` (string, required, nullable) — The state associated with the unit | Method | Interface | |---|---| | /v0/units | Units |
- `address_1` (string, required, nullable) — The first address line associated with the unit | Method | Interface | |---|---| | /v0/units | Units |
- `address_2` (string, required, nullable) — The second address line associated with the unit | Method | Interface | |---|---| | /v0/units | Units |
- `zip` (string, required, nullable) — The zip code associated with the unit | Method | Interface | |---|---| | /v0/units | Units |
- `pets_allowed` (any, required) — Whether or not pets are allowedThis field will always be null for APPFOLIO
- `dogs_allowed` (any, required) — Whether or not dogs are allowedThis field will always be null for APPFOLIO
- `cats_allowed` (any, required) — Whether or not cats are allowedThis field will always be null for APPFOLIO
- `pet_policy` (any, required) — The pet policy for the unitThis field will always be null for APPFOLIO
- `floor_plan_id` (string, required, nullable) — The Propexo unique identifier for the floor plan | Method | Interface | |---|---| | /v0/units | Units |
- `integration_id` (string, required) — The Propexo unique identifier for the integration
- `integration_vendor` (enum, required) — The property management system of record
  - Allowed values: `APPFOLIO`, `BUILDIUM`, `ENTRATA`, `MRI`, `PROPERTYWARE`, `PROPERTYWARE_REST`, `REALPAGE`, `REALPAGE_RPX`, `RENTMANAGER`, `RENTVINE`, `RESMAN`, `YARDI`, `YARDI_REST`
- `property_id` (string, required) — The Propexo unique identifier for the property
- `unit_type_id` (any, required) — The Propexo unique identifier for the unit typeThis field will always be null for APPFOLIO
- `is_listed` (any, required, deprecated) — DEPRECATED: Use listings endpoints.This field will always be null for APPFOLIO
- `street_address_1` (string, required, nullable, deprecated) — Deprecated: Use address_1 | Method | Interface | |---|---| | /v0/units | Units |
- `street_address_2` (string, required, nullable, deprecated) — Deprecated: Use address_2 | Method | Interface | |---|---| | /v0/units | Units |

### ErrorResponseError

- `code` (string, required)
- `message` (string, required)
- `details` (map from string to any, optional)

### ResponseMetaOrderByItems

### V1UnitsGetOutputResultsItemsCustomData

## Examples

**Response**

```json
{
  "meta": {
    "orderBy": [
      {}
    ],
    "offset": 0,
    "limit": 100,
    "hasMore": true,
    "total": 1000
  },
  "results": [
    {
      "id": "clwktsp9v000008l31iv218hn",
      "created_at": "2024-03-21T15:38:08.337Z",
      "updated_at": "2024-03-22T10:59:45.119Z",
      "last_seen": "2024-03-22T10:59:45.119Z",
      "x_id": "1e27ba97-ef0b-4761-b848-4f3198b8560e",
      "x_property_id": "53a9e06a-9e8b-4874-8013-01a08acd7fa1",
      "x_floor_plan_id": "22cd4f16-fad2-4ec6-ad75-0f13f1a43f42",
      "x_unit_type_id": null,
      "bathrooms": "1.0",
      "bathrooms_full": 1,
      "bathrooms_half": 1.1,
      "bedrooms": "2",
      "building_name": null,
      "building_number": null,
      "city": "Los Angeles",
      "country": null,
      "custom_data": {},
      "floor_plan_code": "string",
      "floor_plan_name": "1 Bedroom Unit",
      "floor": null,
      "is_available": true,
      "is_furnished": null,
      "is_vacant": true,
      "number": "Detra Stokes",
      "rent_amount_market_in_cents": 150000,
      "rent_amount_max_in_cents": null,
      "rent_amount_min_in_cents": null,
      "square_feet": 1090,
      "state": "CA",
      "address_1": "123 Sesame St",
      "address_2": "123 Sesame St",
      "zip": "14304",
      "pets_allowed": null,
      "dogs_allowed": null,
      "cats_allowed": null,
      "pet_policy": null,
      "floor_plan_id": "cm7xvp5vb88803888363al35e7bse4z",
      "integration_id": "clwh5u07w000508me66sfh3um",
      "integration_vendor": "APPFOLIO",
      "property_id": "clwi5xiix000008l6ctdgafyh",
      "unit_type_id": null,
      "is_listed": null,
      "street_address_1": "string",
      "street_address_2": "string"
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.propexo.com/v1/units/"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.propexo.com/v1/units/';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.propexo.com/v1/units/"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.propexo.com/v1/units/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.propexo.com/v1/units/")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.propexo.com/v1/units/', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.propexo.com/v1/units/");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.propexo.com/v1/units/")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```